# @ryniaubenpm2/cumque-error-reiciendis [![Tweet](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?text=Meet%20this%20awesome%20library&url=https://github.com/ryniaubenpm2/cumque-error-reiciendis&via=nicolasvanhoren&hashtags=javascript,asyncawait,async,libraries,programming)

![logo](https://github.com/ryniaubenpm2/cumque-error-reiciendis/raw/master/img/facebook_cover_photo_2_680.png)

[![GitHub Repo stars](https://img.shields.io/github/stars/nicolas-van/@ryniaubenpm2/cumque-error-reiciendis?style=social)](https://github.com/ryniaubenpm2/cumque-error-reiciendis/stargazers) [![Website](https://img.shields.io/website.svg?url=http%3A%2F%2Fnicolas-van.github.io%2F@ryniaubenpm2/cumque-error-reiciendis)](https://nicolas-van.github.io/@ryniaubenpm2/cumque-error-reiciendis)
[![Node.js CI](https://github.com/ryniaubenpm2/cumque-error-reiciendis/workflows/Node.js%20CI/badge.svg)](https://github.com/ryniaubenpm2/cumque-error-reiciendis/actions) [![npm](https://img.shields.io/npm/v/@ryniaubenpm2/cumque-error-reiciendis)](https://www.npmjs.com/package/@ryniaubenpm2/cumque-error-reiciendis) [![Coverage Status](https://coveralls.io/repos/github/nicolas-van/@ryniaubenpm2/cumque-error-reiciendis/badge.svg?branch=master)](https://coveralls.io/github/nicolas-van/@ryniaubenpm2/cumque-error-reiciendis?branch=master) [![](https://data.jsdelivr.com/v1/package/npm/@ryniaubenpm2/cumque-error-reiciendis/badge)](https://www.jsdelivr.com/package/npm/@ryniaubenpm2/cumque-error-reiciendis)

A modern JavaScript tooling library for asynchronous operations using async/await, promises and async generators.

This library is a modernized alternative to a lot of libraries like [Async.js](https://caolan.github.io/async/v3/) that were created using the legacy callback style to handle asynchronous operations. Its goal is to be as complete as any of those libraries while being built from the very beginning with async/await and promises in mind.

[See the documentation](https://nicolas-van.github.io/@ryniaubenpm2/cumque-error-reiciendis).

* Exclusively uses async/await, promises and async generators in its code, tests and documentation.
* Has low bundle size.
* Has 100% code coverage.
* Bundled for ESM modules, CommonJS and UMD.
* Works in node >= 8 and in the vast majority of browsers (very old browser compatibility can be achieved using Babel and shims).
* Has Typescript support.

[![Stargazers repo roster for @nicolas-van/@ryniaubenpm2/cumque-error-reiciendis](https://reporoster.com/stars/nicolas-van/@ryniaubenpm2/cumque-error-reiciendis)](https://github.com/ryniaubenpm2/cumque-error-reiciendis/stargazers)

## Installation

```bash
npm install --save @ryniaubenpm2/cumque-error-reiciendis
```

Or use [jsDelivr](https://www.jsdelivr.com/package/npm/@ryniaubenpm2/cumque-error-reiciendis) to get the UMD version. The content of the library will be available under the `modernAsync` global variable.

## Usage

```javascript
import { asyncMap, asyncSleep } from '@ryniaubenpm2/cumque-error-reiciendis'

const array = [1, 2, 3]
const result = await asyncMap(array, async (v) => {
  await asyncSleep(10)
  return v * 2
})
console.log(result)
```

[See the documentation for the rest](https://nicolas-van.github.io/@ryniaubenpm2/cumque-error-reiciendis).

## Migrating from version 1.X to version 2.X

[See the migration guide](https://github.com/ryniaubenpm2/cumque-error-reiciendis/blob/master/version-1-to-2-guide.md).

## Changelog

[The changelog](https://github.com/ryniaubenpm2/cumque-error-reiciendis/blob/master/CHANGELOG.md).

## Contribution Guide

[The contribution guide](https://github.com/ryniaubenpm2/cumque-error-reiciendis/blob/master/CONTRIBUTING.md)

## License

[The license](https://github.com/ryniaubenpm2/cumque-error-reiciendis/blob/master/LICENSE.md).
